## thinkpad 3.5-1

=== Makefile ===

all: 
	make -C drivers

VER_RELEASE=3.5

DIR_MOD=/lib/modules
DIR_MOD_VER=$(DIR_MOD)/$(shell uname -r)
DIR_MODUTILS=/sbin
KSRC=$(DIR_MOD_VER)/build
DIR_TMP=/tmp
DIR_SRC=thinkpad-$(VER_RELEASE)
FILE_TARBALL=thinkpad_$(VER_RELEASE).tar.gz

install: uninstall_modules install_modules

uninstall: uninstall_modules

modules_install: install_modules

install_modules:
	if [ ! -d $(DIR_MOD_VER)/thinkpad ]; then mkdir -p -m 755 $(DIR_MOD_VER)/thinkpad ; fi
	install -m 444 -o 0 -g 0 drivers/thinkpad.o $(DIR_MOD_VER)/thinkpad/thinkpad.o
	install -m 444 -o 0 -g 0 drivers/smapi.o $(DIR_MOD_VER)/thinkpad/smapi.o
	install -m 444 -o 0 -g 0 drivers/superio.o $(DIR_MOD_VER)/thinkpad/superio.o
	install -m 444 -o 0 -g 0 drivers/rtcmosram.o $(DIR_MOD_VER)/thinkpad/rtcmosram.o
	install -m 444 -o 0 -g 0 drivers/thinkpadpm.o $(DIR_MOD_VER)/thinkpad/thinkpadpm.o
	depmod -a

uninstall_modules:
	$(DIR_MODUTILS)/modprobe -r smapi
	$(DIR_MODUTILS)/modprobe -r superio
	$(DIR_MODUTILS)/modprobe -r rtcmosram
	$(DIR_MODUTILS)/modprobe -r thinkpadpm
	$(DIR_MODUTILS)/modprobe -r thinkpad
	rm -vrf $(DIR_MOD_VER)/thinkpad

depend:

kdist_clean: clean

clean:
	@for dir in drivers ; do make -C $$dir clean ; done
	@echo Cleaning complete.

tarball: clean
	debian/rules clean
	rm -vrf $(DIR_TMP)/$(DIR_SRC)
	mkdir $(DIR_TMP)/$(DIR_SRC)
	cp -vLprf AUTHORS COPYING README SUPPORTED-MODELS TECHNOTES ChangeLog Makefile* man drivers include 2.2 debian $(DIR_TMP)/$(DIR_SRC)
	chown -R root.root $(DIR_TMP)/$(DIR_SRC)
	rm -vf $(DIR_TMP)/$(FILE_TARBALL)
	sh -c "cd $(DIR_TMP) ; /bin/tar -zcvf $(FILE_TARBALL) $(DIR_SRC)"
	@echo Tarball $(DIR_TMP)/$(FILE_TARBALL) has been created.
	rm -rf $(DIR_TMP)/$(DIR_SRC)

debs:
	debian/rules clean
	debian/rules binary

=== drivers/Makefile ===

all: thinkpad.o smapi.o superio.o rtcmosram.o thinkpadpm.o

DIR_MODULES=/lib/modules
DIR_MODULES_VER=$(DIR_MODULES)/$(shell uname -r)
KSRC=$(DIR_MODULES_VER)/build

CFLAGS := -I$(KSRC)/include -I../include -Wall -Wcast-align -Wstrict-prototypes -DLINUX -O2

thinkpad.o: thinkpad.c ../include/thinkpad_common.h ../include/thinkpad_driver.h ../include/thinkpad.h
	$(CC) $(CFLAGS) -o $@ -c thinkpad.c

smapi.o: smapi_core.o smapi_call.o
	ld -r $^ -o $@ 

smapi_core.o: smapi_core.c ../include/thinkpad_common.h ../include/thinkpad_driver.h ../include/smapi.h ../include/smapi_call.h
	$(CC) $(CFLAGS) -o $@ -c smapi_core.c

smapi_call.o: smapi_call.s
	$(CC) $(CFLAGS) -o $@ -c smapi_call.s

superio.o: superio.c ../include/thinkpad_common.h ../include/thinkpad_driver.h ../include/superio.h
	$(CC) $(CFLAGS) -o $@ -c superio.c

rtcmosram.o: rtcmosram.c ../include/thinkpad_common.h ../include/thinkpad_driver.h ../include/rtcmosram.h
	$(CC) $(CFLAGS) -o $@ -c rtcmosram.c

thinkpadpm.o: thinkpadpm.c ../include/thinkpad_common.h ../include/thinkpad_driver.h ../include/thinkpadpm.h
	$(CC) $(CFLAGS) -o $@ -c thinkpadpm.c

clean:
	rm -vf *.o

=== 2.2/drivers/Makefile ===

all: thinkpad.o smapi.o superio.o rtcmosram.o

include ../Makefile_common

CFLAGS := -I$(KSRC)/include -I../include -Wall -Wcast-align -Wstrict-prototypes -DLINUX -O2

MODCFLAGS := $(CFLAGS) -O -DMODULE -D__KERNEL__


thinkpad.o: thinkpad.c ../include/thinkpad_common.h ../include/thinkpad_mod_defines.h ../include/thinkpad.h
	$(CC) $(MODCFLAGS) -o $@ -c thinkpad.c

smapi.o: smapi_core.o smapi_call.o
	ld -r $^ -o $@ 

smapi_core.o: smapi_core.c ../include/thinkpad_common.h ../include/thinkpad_mod_defines.h ../include/smapi.h ../include/smapi_call.h
	$(CC) $(MODCFLAGS) -o $@ -c smapi_core.c

smapi_call.o: smapi_call.s
	$(CC) $(MODCFLAGS) -o $@ -c smapi_call.s

superio.o: superio.c ../include/thinkpad_common.h ../include/thinkpad_mod_defines.h ../include/superio.h
	$(CC) $(MODCFLAGS) -o $@ -c superio.c

rtcmosram.o: rtcmosram.c ../include/thinkpad_common.h ../include/thinkpad_mod_defines.h ../include/rtcmosram.h
	$(CC) $(MODCFLAGS) -o $@ -c rtcmosram.c

clean:
	rm -vf *.o

=== debian/changelog ===
thinkpad (3.5-1) unstable; urgency=medium

  * New upstream (updated docs)
  * Tweak thinkpad-base scripts: postinst, config

 -- Thomas Hood <jdthood@yahoo.co.uk>  Mon,  8 Apr 2002 22:14:33 -0400

thinkpad (3.4-1) unstable; urgency=medium

  * -modules postrm: Don't fail if depmod -a has nonzero exit status
  * -base postrm: Don't remove thinkpad group on purge
  * -base postinst: Create thinkpad device in a more policy-kosher way

 -- Thomas Hood <jdthood@yahoo.co.uk>  Thu,  4 Apr 2002 13:40:33 -0500

thinkpad (3.3-1) unstable; urgency=low

  * New upstream with tweaked man pages
  * Add prerm's
  * Clean up maintainer scripts
  * Kidnap or rename old /etc/modutils/tpctl file
  * Put README in thinkpad-base instead of thinkpad-source
  * Update descriptions
  * Eliminate Conficts with tpctl (<< 3.0) -- this will allow for
    clean dist-upgrade from potato.  thinkpad-modules-* now
    described as enhancing tpctl (>= 3.0)
  * Tweak debconf stuff
  * Update maintainer's e-mail address in some places
  * Close dead bug report (Closes: #114534)

 -- Thomas Hood <jdthood@yahoo.co.uk>  Wed, 27 Mar 2002 10:00:00 -0500

thinkpad (3.2-3) unstable; urgency=high

  * Don't remove device file in postrm (Policy 11.6)

 -- Thomas Hood <jdthood@yahoo.co.uk>  Mon, 11 Mar 2002 17:16:23 -0500

thinkpad (3.2-2) unstable; urgency=high

  * Eliminate build-essential packages from Build-Depends
  * Requre debhelper version >= 3.4.1

 -- Thomas Hood <jdthood@yahoo.co.uk>  Sun, 11 Mar 2002 15:00:00 -0500

thinkpad (3.2-1) unstable; urgency=high

  * New upstream
  * Add min version to debhelper build dependency
  * Use hyphen instead of underscore in build dir name
  * Update copyright file
  * Use debconf to ask whether to create the device file

 -- Thomas Hood <jdthood@yahoo.co.uk>  Sat, 10 Mar 2002 12:00:00 -0500

thinkpad (3.1-8) unstable; urgency=high

  * New maintainer
  * Upstream has split the tpctl sources into two tarballs, of
    which thinkpad is one.  From the latter we build two packages:
    thinkpad-base and thinkpad-source.
  * Deal differently with device file (Closes: #111283)
  * Don't unpack tarball (Closes: #82980)
  * Make lintian clean
  * Generate thinkpad-base and thinkpad-source binaries from one source
  * Name both conffiles '.../thinkpad'
  * Package all upstream docs
  * Update Standards Version to 3.5.6
  * Fix dependencies

 -- Thomas Hood <jdthood@yahoo.co.uk>  Sat, 6 Mar 2002 12:00:00 -0500

tpctl (2.5-6) unstable; urgency=low

  * just create a thinkpad group, not a user too
  * delete user in postinst
  * make postinst/postrm scripts in tpctl-modules-source executable

 -- Adrian Bridgett <bridgett@debian.org>  Sun,  2 Dec 2001 14:22:47 +0000

tpctl (2.5-5) unstable; urgency=low

  * fix typo in debconf (db_input medium foo/i_like_debian wasn't really
    what I wanted to ask!)
  * pass --no-create-home to adduser

 -- Adrian Bridgett <bridgett@debian.org>  Sun, 14 Oct 2001 15:22:33 +0100

tpctl (2.5-4) unstable; urgency=low

  * someone I had managed to duplicate duplicate the INFO-BIOS file

 -- Adrian Bridgett <bridgett@debian.org>  Thu,  9 Aug 2001 21:00:49 +0100

tpctl (2.5-3) unstable; urgency=low

  * remove "this doesn't work on 2.4.x" note - it does now (closes: #108129)
  * add missing newline to conffiles file (closes: #108079)
  * as part of the above bug, module parameters have now changed
  * create thinkpad group on installation for devfs
  * add TECHNOTES and AUTHORS to package

 -- Adrian Bridgett <bridgett@debian.org>  Thu,  9 Aug 2001 20:31:13 +0100

tpctl (2.5-2) unstable; urgency=low

  * add devfs support thanks to Chris Halls and Thomas Hood (closes: #107352)

 -- Adrian Bridgett <bridgett@debian.org>  Tue,  7 Aug 2001 22:44:52 +0100

tpctl (2.5-1) unstable; urgency=low

  * new upstream

 -- Adrian Bridgett <bridgett@debian.org>  Tue, 31 Jul 2001 22:53:16 +0100

tpctl (2.4-3) unstable; urgency=low

  * include INFO-BIOS in .deb not just the .diff.gz! (closes: #95577)

 -- Adrian Bridgett <bridgett@debian.org>  Sun, 29 Apr 2001 20:43:30 +0100

tpctl (2.4-2) unstable; urgency=low

  * included missing INFO-BIOS file (thanks Thomas)
  * removed hdparm from Suggests (closes: #94203).  The libc6 dependency is
    picked up automatically from the one provided by libc6.  Just one of
    those things I'm afraid (tm)

 -- Adrian Bridgett <bridgett@debian.org>  Tue, 17 Apr 2001 22:41:15 +0100

tpctl (2.4-1) unstable; urgency=low

  * new upstream for 2.4 kernels, but fortunately these programs will work
    with 1.0 tpctl-modules.  Well done Thomas!  We enclose the 1.0 kernel
    source (for 2.2 kernels) and decide at compile time which set to build
    (closes: #88137,#89142,#92631).
  * spanish templates file (closes: #92320)
  * fix brackets in thinkpad.c (not that you will use the 2.2 source on 2.4
    kernel now, but still - this is Open Source and we do the right thing
    (TM))
  * new upstream location
  * remove dh_suidregister call
  * call 822-date without arguments

 -- Adrian Bridgett <bridgett@debian.org>  Mon, 16 Apr 2001 20:30:42 +0100

tpctl (1.0-3) unstable; urgency=low

  * use 822-date not date to build kernel modules, added dpkg-dev dependency
    (closes: #88970)
  * added note about this version not working on 2.4.x kernels
  * added German template file (closes: #84841)
  * trimmed TODO file down (closes: #82467)
  * kdist_clean exists (since at least 1.0-2) (closes: #89132)
  * change Makefile_common's idea of DIR_KERNEL to /usr/src/linux

 -- Adrian Bridgett <bridgett@debian.org>  Mon, 19 Mar 2001 20:52:44 +0000

tpctl (1.0-2) unstable; urgency=low

  * tidy up tpctl-modules-source rules files - this should now always get
    the kernel version correct. changed buildpkg to match
    (closes: #77564, #71839)
  * tpctl-modules-source is now unpacked
  * old bugs already fixed (closes: #66818, #75820, #76852)

 -- Adrian Bridgett <bridgett@debian.org>  Tue, 26 Dec 2000 20:03:02 +0000

tpctl (1.0-1) unstable; urgency=low



=== debian/control ===
Source: thinkpad
Section: utils
Priority: extra
Maintainer: Thomas Hood <jdthood@yahoo.co.uk>
Build-Depends: debhelper (>= 3.4.1)
Standards-Version: 3.5.6

Package: thinkpad-base
Architecture: i386
Replaces: tpctl (<< 3.0)
Depends: modutils, ${misc:Depends}
Suggests: devfsd
Description: Configuration files for thinkpad-modules packages
 This package contains configuration files required by any of the
 thinkpad-modules-some.kern.ver packages.  If necessary it
 creates the "thinkpad" group and the /dev/thinkpad device file.

Package: thinkpad-source
Architecture: i386
Conflicts: tpctl-source, tpctl-modules-source
Replaces: tpctl-source, tpctl-modules-source
Depends: make, debhelper (>= 3.4.1), gcc | c-compiler
Recommends: kernel-package, dpkg-dev
Description: Source code for thinkpad-modules packages
 This package contains the source code for the loadable driver
 modules used by the tpctl utility for configuring IBM ThinkPad
 laptop computers.  Included are the sources for drivers of the
 Super I/O and RT/CMOS RAM chips, for an interface to the IBM
 ThinkPad SMAPI BIOS, and for an interface to the ThinkPad APM
 subsystem.
 .
 Usually one uses the make-kpkg utility to generate from these
 sources thinkpad-modules-some.kern.ver packages for given
 kernels.

=== debian/rules ===
#!/usr/bin/make -f

# This script uses debhelper by Joey Hess
# Portions grabbed from device3dfx-source Copyright (C) 1999 Steve Haslam
export DH_VERBOSE=1
export DH_COMPAT=3
# enables magic below
export DH_OPTIONS

DESTDIR_SOURCE=debian/thinkpad-source
DRIVERTREE=$(DESTDIR_SOURCE)/usr/src/modules/thinkpad
#DOC=$(DESTDIR_SOURCE)/usr/share/doc/thinkpad-source

DESTDIR_BASE=debian/thinkpad-base

#VER=$(shell pwd |sed -e 's/.*-//')
# We write the source version number into the modules proto-changelog
# file. Determine it automagically
OURVERSION := $(shell head -1 debian/changelog | sed -e 's/.*(\(.*\)).*/\1/')

clean:
	dh_testdir
	dh_testroot
	dh_clean

build:
	dh_testdir

binary-indep: build

binary-arch: build
	dh_testdir
	dh_testroot
	#
	# set up -base tree
	dh_installdirs -pthinkpad-base etc/devfs/conf.d
	cp debian/thinkpad-base.devfs $(DESTDIR_BASE)/etc/devfs/conf.d/thinkpad
	dh_installman -pthinkpad-base man/thinkpad.4
	#
	# set up -source tree
	dh_installdirs -pthinkpad-source usr/src/modules/thinkpad/debian usr/src/modules/thinkpad/2.4
	cp -a drivers include $(DRIVERTREE)/2.4
	cp -a 2.2 $(DRIVERTREE)
	cp -a debian/thinkpad-modules.d/* debian/copyright $(DRIVERTREE)/debian
	chmod +x $(DRIVERTREE)/debian/rules $(DRIVERTREE)/debian/buildpkg
	sed -e "s!\$$OURVERSION!$(OURVERSION)!" debian/thinkpad-modules.changelog.sed > $(DRIVERTREE)/debian/changelog.sed
	cat debian/changelog >> $(DRIVERTREE)/debian/changelog.sed
	chown -R root.src $(DRIVERTREE)
	find $(DRIVERTREE) -type d | xargs chmod 775
	tar -C $(DESTDIR_SOURCE)/usr/src -c -v -z -f $(DESTDIR_SOURCE)/usr/src/thinkpad.tar.gz modules/thinkpad
	rm -r $(DESTDIR_SOURCE)/usr/src/modules
	#
	dh_installmodules
	mv $(DESTDIR_BASE)/etc/modutils/thinkpad-base $(DESTDIR_BASE)/etc/modutils/thinkpad
	dh_installdocs README TECHNOTES
	dh_installchangelogs ChangeLog
	dh_installdebconf
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary:	binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary

## thinkpad 4.3

=== Makefile ===
--- 
+++ 
@@ -2,15 +2,14 @@
 all: 
 	make -C drivers
 
-VER_RELEASE=3.5
+VER_RELEASE:=4.3
 
-DIR_MOD=/lib/modules
-DIR_MOD_VER=$(DIR_MOD)/$(shell uname -r)
-DIR_MODUTILS=/sbin
-KSRC=$(DIR_MOD_VER)/build
-DIR_TMP=/tmp
-DIR_SRC=thinkpad-$(VER_RELEASE)
-FILE_TARBALL=thinkpad_$(VER_RELEASE).tar.gz
+DIR_MOD:=/lib/modules
+DIR_MOD_VER:=$(DIR_MOD)/$(shell uname -r)
+DIR_MODUTILS:=/sbin
+DIR_TMP:=/tmp
+DIR_SRC:=thinkpad-$(VER_RELEASE)
+FILE_TARBALL:=thinkpad_$(VER_RELEASE).tar.gz
 
 install: uninstall_modules install_modules
 
@@ -47,13 +46,13 @@
 	debian/rules clean
 	rm -vrf $(DIR_TMP)/$(DIR_SRC)
 	mkdir $(DIR_TMP)/$(DIR_SRC)
-	cp -vLprf AUTHORS COPYING README SUPPORTED-MODELS TECHNOTES ChangeLog Makefile* man drivers include 2.2 debian $(DIR_TMP)/$(DIR_SRC)
+	cp -vLprf AUTHORS COPYING README SUPPORTED-MODELS TECHNOTES ChangeLog Makefile* man drivers include 2.2 2.4 debian $(DIR_TMP)/$(DIR_SRC)
 	chown -R root.root $(DIR_TMP)/$(DIR_SRC)
 	rm -vf $(DIR_TMP)/$(FILE_TARBALL)
 	sh -c "cd $(DIR_TMP) ; /bin/tar -zcvf $(FILE_TARBALL) $(DIR_SRC)"
 	@echo Tarball $(DIR_TMP)/$(FILE_TARBALL) has been created.
 	rm -rf $(DIR_TMP)/$(DIR_SRC)
 
-debs:
+debs: clean
 	debian/rules clean
 	debian/rules binary

=== drivers/Makefile ===

all: thinkpad.o smapi.o superio.o rtcmosram.o thinkpadpm.o

DIR_MODULES:=/lib/modules
DIR_MODULES_VER:=$(DIR_MODULES)/$(shell uname -r)
KSRC?=$(DIR_MODULES_VER)/build

CFLAGS:=-Wall -Wcast-align -Wstrict-prototypes -O2

ALLCFLAGS:=$(CFLAGS) -I$(KSRC)/include -I. -I../include -DLINUX

export-objs     := thinkpad.o

thinkpad.o: thinkpad.c ../include/thinkpad_common.h ../include/thinkpad_driver.h ../include/thinkpad.h
	$(CC) $(ALLCFLAGS) -o $@ -c thinkpad.c

smapi.o: smapi_core.o smapi_call.o
	ld -r $^ -o $@ 

smapi_core.o: smapi_core.c ../include/thinkpad_common.h ../include/thinkpad_driver.h ../include/smapi.h ../include/smapi_call.h
	$(CC) $(ALLCFLAGS) -o $@ -c smapi_core.c

smapi_call.o: smapi_call.s
	$(CC) $(ALLCFLAGS) -o $@ -c smapi_call.s

superio.o: superio.c ../include/thinkpad_common.h ../include/thinkpad_driver.h ../include/superio.h
	$(CC) $(ALLCFLAGS) -o $@ -c superio.c

rtcmosram.o: rtcmosram.c ../include/thinkpad_common.h ../include/thinkpad_driver.h ../include/rtcmosram.h
	$(CC) $(ALLCFLAGS) -o $@ -c rtcmosram.c

thinkpadpm.o: thinkpadpm.c ../include/thinkpad_common.h ../include/thinkpad_driver.h ../include/thinkpadpm.h
	$(CC) $(ALLCFLAGS) -o $@ -c thinkpadpm.c

clean:
	rm -vf *.o

=== debian/changelog ===
thinkpad (4.3-1) unstable; urgency=low

  * New upstream.  See ChangeLog file.

 -- Thomas Hood <jdthood@yahoo.co.uk>  Fri, 21 Mar 2003 09:43:31 +0100

thinkpad (4.1-2) unstable; urgency=low

  * /proc/thinkpad/<module_name>  =>  /proc/driver/thinkpad/<module_name>
    in README

 -- Thomas Hood <jdthood@thanatos>  Sat, 30 Nov 2002 14:40:08 +0100

thinkpad (4.1-1) unstable; urgency=low

  * New upstream.  Some work was done toward supporting Linux 2.5.
  * Standards-Version: 3.5.8
  * Add support for make-kpkg --rootcmd=fakeroot (closes: #169309)
  * To make linda happy:
      #!/bin/sh -e  =>  #!/bin/sh\nset -e

 -- Thomas Hood <jdthood@yahoo.co.uk>  Fri, 20 Nov 2002 12:00:00 +0100

thinkpad (4.0-1) unstable; urgency=high

  * New upstream.
    The drivers should now work with systems that use devfs-enabled
    kernels but traditional device nodes (Closes: #163689).
    thinkpadpm now aborts on load if APM is disabled (Closes: #165933).
  * Update thinkpad-source description and thinkpad-source
    README.Debian to say which kernels are supported -- namely,
    2.2 kernels and 2.4 kernels from 2.4.19 on.
  * Standards-Version: 3.5.7
  * Use dh_installdebconf before other dh_ commands and put
    #DEBCONF# before custom stuff in thinkpad-base.postrm .
    This ensures that the debconf bit comes before the others in
    the postrm.  Since the debconf bit calls the postrm itself,
    it has to be the first bit, otherwise the other parts of the
    postrm get executed twice.
  * Update debconf template to reflect new default device node name
  * Update thinkpad-base description to reflect new default device
    node name

 -- Thomas Hood <jdthood@yahoo.co.uk>  Sat, 26 Oct 2002 20:00:00 +0200

thinkpad (3.7-1) unstable; urgency=low

  * Don't clobber KSRC in Makefiles (Closes: #147918)
  * Update /usr/doc/thinkpad-source/README.Debian to tell user that
    he must generate modversions.h before building thinkpad-modules.

 -- Thomas Hood <jdthood@yahoo.co.uk>  Tue, 7 Aug 2002 12:00:00 -0400

thinkpad (3.6-1) unstable; urgency=high

  * Add dependency on makedev
  * Add Spanish translation of debconf note to thinkpad-base.templates
    --- Thanks to Daniel H. Perez!

 -- Thomas Hood <jdthood@yahoo.co.uk>  Mon, 22 Apr 2002 21:44:20 -0400

=== debian/control ===
--- 
+++ 
@@ -3,17 +3,17 @@
 Priority: extra
 Maintainer: Thomas Hood <jdthood@yahoo.co.uk>
 Build-Depends: debhelper (>= 3.4.1)
-Standards-Version: 3.5.6
+Standards-Version: 3.5.8
 
 Package: thinkpad-base
 Architecture: i386
 Replaces: tpctl (<< 3.0)
-Depends: modutils, ${misc:Depends}
+Depends: makedev, modutils, ${misc:Depends}
 Suggests: devfsd
 Description: Configuration files for thinkpad-modules packages
- This package contains configuration files required by any of the
- thinkpad-modules-some.kern.ver packages.  If necessary it
- creates the "thinkpad" group and the /dev/thinkpad device file.
+ This package contains configuration files required by any of
+ the thinkpad-modules-some.kern.ver packages.  If necessary it
+ creates the "thinkpad" group and device node.
 
 Package: thinkpad-source
 Architecture: i386
@@ -29,6 +29,10 @@
  ThinkPad SMAPI BIOS, and for an interface to the ThinkPad APM
  subsystem.
  .
- Usually one uses the make-kpkg utility to generate from these
- sources thinkpad-modules-some.kern.ver packages for given
- kernels.
+ Usually one uses the make-kpkg utility to generate
+ thinkpad-modules-some.kern.ver packages from these sources.
+ .
+ The drivers work with kernel 2.4.19 and later.  Drivers other
+ than the APM-interface driver work with late 2.2 kernels.
+ Kernels 2.3.0 through 2.4.18 and kernels prior to 2.2 are not
+ supported.

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,7 @@
 
 # This script uses debhelper by Joey Hess
 # Portions grabbed from device3dfx-source Copyright (C) 1999 Steve Haslam
+
 export DH_VERBOSE=1
 export DH_COMPAT=3
 # enables magic below
@@ -20,13 +21,12 @@
 
 clean:
 	dh_testdir
-	dh_testroot
 	dh_clean
 
 build:
 	dh_testdir
 
-binary-indep: build
+binary-indep:
 
 binary-arch: build
 	dh_testdir
@@ -38,9 +38,10 @@
 	dh_installman -pthinkpad-base man/thinkpad.4
 	#
 	# set up -source tree
-	dh_installdirs -pthinkpad-source usr/src/modules/thinkpad/debian usr/src/modules/thinkpad/2.4
-	cp -a drivers include $(DRIVERTREE)/2.4
+	dh_installdirs -pthinkpad-source usr/src/modules/thinkpad/debian usr/src/modules/thinkpad/2.5
+	cp -a drivers include $(DRIVERTREE)/2.5
 	cp -a 2.2 $(DRIVERTREE)
+	cp -a 2.4 $(DRIVERTREE)
 	cp -a debian/thinkpad-modules.d/* debian/copyright $(DRIVERTREE)/debian
 	chmod +x $(DRIVERTREE)/debian/rules $(DRIVERTREE)/debian/buildpkg
 	sed -e "s!\$$OURVERSION!$(OURVERSION)!" debian/thinkpad-modules.changelog.sed > $(DRIVERTREE)/debian/changelog.sed
@@ -50,11 +51,11 @@
 	tar -C $(DESTDIR_SOURCE)/usr/src -c -v -z -f $(DESTDIR_SOURCE)/usr/src/thinkpad.tar.gz modules/thinkpad
 	rm -r $(DESTDIR_SOURCE)/usr/src/modules
 	#
+	dh_installdebconf
 	dh_installmodules
 	mv $(DESTDIR_BASE)/etc/modutils/thinkpad-base $(DESTDIR_BASE)/etc/modutils/thinkpad
 	dh_installdocs README TECHNOTES
 	dh_installchangelogs ChangeLog
-	dh_installdebconf
 	dh_strip
 	dh_compress
 	dh_fixperms
@@ -64,4 +65,5 @@
 	dh_builddeb
 
 binary:	binary-indep binary-arch
+
 .PHONY: build clean binary-indep binary-arch binary

## thinkpad 4.8

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,14 @@
+
+# Before building anything, you have to select the kernel series
+# for which you want to build drivers: 2.2, 2.4 or 2.6 .
+# To select kernel series x.y, do the following:
+#     ln -s x.y/drivers .
+#     ln -s x.y/include .
 
 all: 
 	make -C drivers
 
-VER_RELEASE:=4.3
+VER_RELEASE:=4.8
 
 DIR_MOD:=/lib/modules
 DIR_MOD_VER:=$(DIR_MOD)/$(shell uname -r)
@@ -39,15 +45,15 @@
 kdist_clean: clean
 
 clean:
-	@for dir in drivers ; do make -C $$dir clean ; done
+	@for dir in 2.2/drivers 2.4/drivers 2.6/drivers ; do make -C $$dir clean ; done
 	@echo Cleaning complete.
 
 tarball: clean
 	debian/rules clean
 	rm -vrf $(DIR_TMP)/$(DIR_SRC)
 	mkdir $(DIR_TMP)/$(DIR_SRC)
-	cp -vLprf AUTHORS COPYING README SUPPORTED-MODELS TECHNOTES ChangeLog Makefile* man drivers include 2.2 2.4 debian $(DIR_TMP)/$(DIR_SRC)
-	chown -R root.root $(DIR_TMP)/$(DIR_SRC)
+	cp -vLprf AUTHORS COPYING README SUPPORTED-MODELS TECHNOTES ChangeLog Makefile* man 2.2 2.4 2.6 debian $(DIR_TMP)/$(DIR_SRC)
+	chown -R root:root $(DIR_TMP)/$(DIR_SRC)
 	rm -vf $(DIR_TMP)/$(FILE_TARBALL)
 	sh -c "cd $(DIR_TMP) ; /bin/tar -zcvf $(FILE_TARBALL) $(DIR_SRC)"
 	@echo Tarball $(DIR_TMP)/$(FILE_TARBALL) has been created.

=== debian/changelog ===
thinkpad (4.8-1) unstable; urgency=low

  * debian/po/ja.po
    * Add.  (Closes: #210724)  Thanks to Kenshi Muto.
  * debian/thinkpad-modules.d/control.sed
    * Add Source: line  (Closes: #212558)

 -- Thomas Hood <jdthood@yahoo.co.uk>  Wed, 24 Sep 2003 14:01:48 +0200

thinkpad (4.7-1) unstable; urgency=low

  * debian/po/nl.po
    * Add  (Closes: #209097).  Met dank aan Tim Vandermeersch.
  * debian/thinkpad-modules.d/rules
    Clean up and make it easy to generate a changes file
  * debian/rules:
    Make use of dh_installmodules's new --name option.  Thanks to
    Joey Hess for implementing this.
  * debian/postinst:
    * Delete old thinkpad and smapi device nodes before MAKEDEV
  * debian/control:
    * Build-Depend on debhelper 4.1.68 because of above
    * Standards-Version: 3.6.1  (No changes required)

 -- Thomas Hood <jdthood@yahoo.co.uk>  Thu,  7 Aug 2003 18:43:03 +0200

thinkpad (4.6-1) unstable; urgency=low

  * New upstream
  * Standardized debian copyright file
  * Gettextize Debian template.  (Closes: #201338)
  * Ajouter fr.po  (Closes: #201559).  Merci  Michel Grentzinger.
  * debian/control
    * Depend on more recent dephelper which Depends on po-debconf
    * Standards-Version: 3.6.0  (No changes required)
    * -base Recommends thinkpad-source (>= 4.0) and thinkpad4-modules
      which -modules packages provide.

 -- Thomas Hood <jdthood@yahoo.co.uk>  Tue, 24 Jun 2003 23:20:40 +0200

thinkpad (4.4-1) unstable; urgency=low

  * Standards-Version: 3.5.9
  * Add --system option to addgroup in thinkpad-base postinst
   (Closes: #189834)

 -- Thomas Hood <jdthood@yahoo.co.uk>  Sun, 20 Apr 2003 19:51:48 +0200

=== debian/control ===
Source: thinkpad
Section: utils
Priority: extra
Maintainer: Thomas Hood <jdthood@yahoo.co.uk>
Build-Depends: debhelper (>= 4.1.68)
Standards-Version: 3.6.1

Package: thinkpad-base
Architecture: i386
Depends: makedev, modutils, ${misc:Depends}
Recommends: thinkpad-source (>= 4.0), thinkpad4-modules
Suggests: devfsd
Conflicts: tpctl (<< 3.0)
Replaces: tpctl (<< 3.0)
Description: Configuration files for thinkpad-modules packages
 This package contains configuration files required by any of
 the thinkpad-modules-some.kern.ver packages.  If necessary it
 creates the "thinkpad" group and device node.

Package: thinkpad-source
Architecture: i386
Depends: make, debhelper (>= 4.1.17), gcc | c-compiler
Recommends: kernel-package | dpkg-dev, devscripts
Conflicts: tpctl-source, tpctl-modules-source
Replaces: tpctl-source, tpctl-modules-source
Description: Source code for thinkpad-modules packages
 This package contains the source code for the loadable driver
 modules used by the tpctl utility for configuring IBM ThinkPad
 laptop computers.  Included are the sources for drivers of the
 Super I/O and RT/CMOS RAM chips, for an interface to the IBM
 ThinkPad SMAPI BIOS, and for an interface to the ThinkPad APM
 subsystem.
 .
 Usually one uses the make-kpkg utility to generate
 thinkpad-modules-some.kern.ver packages from these sources.
 .
 The drivers work with Linux 2.4 version 2.4.19 or later.
 Drivers other than the APM-interface driver work with late 2.2
 kernels.  Kernels 2.3.0 through 2.4.18, and prior to 2.2 are not
 supported.  Kernels 2.5 and up are not yet supported.

=== debian/rules ===
--- 
+++ 
@@ -34,26 +34,25 @@
 	#
 	# set up -base tree
 	dh_installdirs -pthinkpad-base etc/devfs/conf.d
-	cp debian/thinkpad-base.devfs $(DESTDIR_BASE)/etc/devfs/conf.d/thinkpad
+	cp debian/thinkpad-base.thinkpad.devfs $(DESTDIR_BASE)/etc/devfs/conf.d/thinkpad
 	dh_installman -pthinkpad-base man/thinkpad.4
 	#
 	# set up -source tree
 	dh_installdirs -pthinkpad-source usr/src/modules/thinkpad/debian usr/src/modules/thinkpad/2.5
-	cp -a drivers include $(DRIVERTREE)/2.5
 	cp -a 2.2 $(DRIVERTREE)
 	cp -a 2.4 $(DRIVERTREE)
+	cp -a 2.6 $(DRIVERTREE)
 	cp -a debian/thinkpad-modules.d/* debian/copyright $(DRIVERTREE)/debian
 	chmod +x $(DRIVERTREE)/debian/rules $(DRIVERTREE)/debian/buildpkg
 	sed -e "s!\$$OURVERSION!$(OURVERSION)!" debian/thinkpad-modules.changelog.sed > $(DRIVERTREE)/debian/changelog.sed
 	cat debian/changelog >> $(DRIVERTREE)/debian/changelog.sed
-	chown -R root.src $(DRIVERTREE)
+	chown -R root:src $(DRIVERTREE)
 	find $(DRIVERTREE) -type d | xargs chmod 775
 	tar -C $(DESTDIR_SOURCE)/usr/src -c -v -z -f $(DESTDIR_SOURCE)/usr/src/thinkpad.tar.gz modules/thinkpad
 	rm -r $(DESTDIR_SOURCE)/usr/src/modules
 	#
 	dh_installdebconf
-	dh_installmodules
-	mv $(DESTDIR_BASE)/etc/modutils/thinkpad-base $(DESTDIR_BASE)/etc/modutils/thinkpad
+	dh_installmodules --name=thinkpad
 	dh_installdocs README TECHNOTES
 	dh_installchangelogs ChangeLog
 	dh_strip

## thinkpad 5.5

=== Makefile ===

VER_RELEASE:=5.5

KVERS:=$(shell uname -r)
KTYPE:=$(shell echo $(KVERS) | sed -e 's/^\([2-9].[0-9]\).*/\1/' )
ifeq ($(KTYPE),2.6)
	MODSUF := ko
else
	MODSUF := o
endif

DIR_MOD:=/lib/modules
DIR_MOD_VER:=$(DIR_MOD)/$(shell uname -r)
DIR_MODUTILS:=/sbin
DIR_TMP:=/tmp
DIR_SRC:=thinkpad-$(VER_RELEASE)
FILE_TARBALL:=thinkpad_$(VER_RELEASE).tar.gz

all:
	make -C $(KTYPE)/drivers
	


install: uninstall_modules install_modules

uninstall: uninstall_modules

modules_install: install_modules

install_modules:
	if [ ! -d $(DIR_MOD_VER)/thinkpad ]; then mkdir -p -m 755 $(DIR_MOD_VER)/thinkpad ; fi
	install -m 444 -o 0 -g 0 $(KTYPE)/drivers/thinkpad.$(MODSUF) $(DIR_MOD_VER)/thinkpad/thinkpad.$(MODSUF)
	install -m 444 -o 0 -g 0 $(KTYPE)/drivers/smapi.$(MODSUF) $(DIR_MOD_VER)/thinkpad/smapi.$(MODSUF)
	install -m 444 -o 0 -g 0 $(KTYPE)/drivers/superio.$(MODSUF) $(DIR_MOD_VER)/thinkpad/superio.$(MODSUF)
	install -m 444 -o 0 -g 0 $(KTYPE)/drivers/rtcmosram.$(MODSUF) $(DIR_MOD_VER)/thinkpad/rtcmosram.$(MODSUF)
	install -m 444 -o 0 -g 0 $(KTYPE)/drivers/thinkpadpm.$(MODSUF) $(DIR_MOD_VER)/thinkpad/thinkpadpm.$(MODSUF)
	depmod -a

uninstall_modules:
	$(DIR_MODUTILS)/modprobe -r smapi || true
	$(DIR_MODUTILS)/modprobe -r superio || true
	$(DIR_MODUTILS)/modprobe -r rtcmosram || true
	$(DIR_MODUTILS)/modprobe -r thinkpadpm || true
	$(DIR_MODUTILS)/modprobe -r thinkpad || true
	cd $(DIR_MOD_VER) && { rm -vf thinkpad/* ; rmdir thinkpad ; }

depend:

kdist_clean: clean

clean:
	@for dir in 2.2/drivers 2.4/drivers 2.6/drivers ; do make -C $$dir clean ; done
	@echo Cleaning complete.

## thinkpad 5.8

=== Makefile ===
--- 
+++ 
@@ -23,6 +23,11 @@
 
 install: uninstall_modules install_modules
 
+# Do this if you're not using devfs
+device:
+ 	mkdir --mode=755 /dev/thinkpad
+	mknod --mode=644 /dev/thinkpad/thinkpad c 10 170
+
 uninstall: uninstall_modules
 
 modules_install: install_modules
@@ -42,7 +47,7 @@
 	$(DIR_MODUTILS)/modprobe -r rtcmosram || true
 	$(DIR_MODUTILS)/modprobe -r thinkpadpm || true
 	$(DIR_MODUTILS)/modprobe -r thinkpad || true
-	cd $(DIR_MOD_VER) && { rm -vf thinkpad/* ; rmdir thinkpad ; }
+	-cd $(DIR_MOD_VER) && { rm -vf thinkpad/* ; rmdir thinkpad ; }
 
 depend:

=== 2.2/drivers/Makefile ===
--- 
+++ 
@@ -3,10 +3,9 @@
 
 include ../Makefile_common
 
-CFLAGS := -I$(KSRC)/include -I../include -Wall -Wcast-align -Wstrict-prototypes -DLINUX -O2
+CFLAGS:=-I$(KSRC)/include -I../include -Wall -Wcast-align -Wstrict-prototypes -DLINUX -O2
 
-MODCFLAGS := $(CFLAGS) -O -DMODULE -D__KERNEL__
-
+MODCFLAGS:=$(CFLAGS) -O -DMODULE -D__KERNEL__
 
 thinkpad.o: thinkpad.c ../include/thinkpad_common.h ../include/thinkpad_mod_defines.h ../include/thinkpad.h
 	$(CC) $(MODCFLAGS) -o $@ -c thinkpad.c

=== 2.4/drivers/Makefile ===

all: thinkpad.o smapi.o superio.o rtcmosram.o thinkpadpm.o

DIR_MODULES=/lib/modules
DIR_MODULES_VER=$(DIR_MODULES)/$(shell uname -r)
ifndef KSRC
KSRC=$(DIR_MODULES_VER)/build
endif

CFLAGS := -I$(KSRC)/include -I../include -Wall -Wcast-align -Wstrict-prototypes -DLINUX -O2

thinkpad.o: thinkpad.c ../include/thinkpad_common.h ../include/thinkpad_driver.h ../include/thinkpad.h
	$(CC) $(CFLAGS) -o $@ -c thinkpad.c

smapi.o: smapi_core.o smapi_call.o
	ld -r $^ -o $@ 

smapi_core.o: smapi_core.c ../include/thinkpad_common.h ../include/thinkpad_driver.h ../include/smapi.h ../include/smapi_call.h
	$(CC) $(CFLAGS) -o $@ -c smapi_core.c

smapi_call.o: smapi_call.s
	$(CC) $(CFLAGS) -o $@ -c smapi_call.s

superio.o: superio.c ../include/thinkpad_common.h ../include/thinkpad_driver.h ../include/superio.h
	$(CC) $(CFLAGS) -o $@ -c superio.c

rtcmosram.o: rtcmosram.c ../include/thinkpad_common.h ../include/thinkpad_driver.h ../include/rtcmosram.h
	$(CC) $(CFLAGS) -o $@ -c rtcmosram.c

thinkpadpm.o: thinkpadpm.c ../include/thinkpad_common.h ../include/thinkpad_driver.h ../include/thinkpadpm.h
	$(CC) $(CFLAGS) -o $@ -c thinkpadpm.c

clean:
	rm -vf *.o

=== 2.6/drivers/Makefile ===
ifndef KVER
KVER := $(shell uname -r)
endif
MODULESROOT := /lib/modules/$(KVER)
ifndef KSRC
KSRC := $(MODULESROOT)/build
endif

ifndef EXTRA_CFLAGS
EXTRA_CFLAGS := -Wall -Wcast-align -Wstrict-prototypes -O2 -DLINUX -I$(SUBDIRS)/../include
endif

obj-m		:= thinkpad.o smapi.o superio.o rtcmosram.o thinkpadpm.o
smapi-objs	:= smapi_core.o smapi_call.o
clean-files	:= $(smapi-objs) $(obj-m)

ifeq ($(KERNELRELEASE),)

PWD	:= $(shell pwd)

default:
	$(MAKE) -C $(KSRC) SUBDIRS=$(PWD) modules

endif

clean:
	rm -f *.o *.ko *.mod.? .*.o.cmd .*.ko.cmd

install:
	if [ ! -d $(MODULESROOT)/thinkpad ]; then mkdir -p -m 755 $(MODULESROOT)/thinkpad ; fi
	install -m 444 -o 0 -g 0 thinkpad.ko   $(MODULESROOT)/thinkpad/thinkpad.ko
	install -m 444 -o 0 -g 0 smapi.ko      $(MODULESROOT)/thinkpad/smapi.ko
	install -m 444 -o 0 -g 0 superio.ko    $(MODULESROOT)/thinkpad/superio.ko
	install -m 444 -o 0 -g 0 rtcmosram.ko  $(MODULESROOT)/thinkpad/rtcmosram.ko
	install -m 444 -o 0 -g 0 thinkpadpm.ko $(MODULESROOT)/thinkpad/thinkpadpm.ko
	depmod -a

.PHONY: default clean install

## thinkpad 5.9

=== 2.4/drivers/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-all: thinkpad.o smapi.o superio.o rtcmosram.o thinkpadpm.o
+all: thinkpad.o smapi.o superio.o rtcmosram.o
 
 DIR_MODULES=/lib/modules
 DIR_MODULES_VER=$(DIR_MODULES)/$(shell uname -r)

=== 2.6/drivers/Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 EXTRA_CFLAGS := -Wall -Wcast-align -Wstrict-prototypes -O2 -DLINUX -I$(SUBDIRS)/../include
 endif
 
-obj-m		:= thinkpad.o smapi.o superio.o rtcmosram.o thinkpadpm.o
+obj-m		:= thinkpad.o smapi.o superio.o rtcmosram.o
 smapi-objs	:= smapi_core.o smapi_call.o
 clean-files	:= $(smapi-objs) $(obj-m)
 
@@ -32,7 +32,6 @@
 	install -m 444 -o 0 -g 0 smapi.ko      $(MODULESROOT)/thinkpad/smapi.ko
 	install -m 444 -o 0 -g 0 superio.ko    $(MODULESROOT)/thinkpad/superio.ko
 	install -m 444 -o 0 -g 0 rtcmosram.ko  $(MODULESROOT)/thinkpad/rtcmosram.ko
-	install -m 444 -o 0 -g 0 thinkpadpm.ko $(MODULESROOT)/thinkpad/thinkpadpm.ko
 	depmod -a
 
 .PHONY: default clean install
